package sample;

import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodType;

abstract class Base {
    public void foo(double value) {
        System.out.println("foo(double) called.");
    }
}

class Derived extends Base {
    public void foo(int value) {
        System.out.println("foo(int) called.");
    }
}

public class Sample {
    public static void main(String[] args) throws Throwable {
        System.out.println("Calling using plain vanilla polymorphism");
        callFooOn(new Derived());

        System.out.println("Calling using methodhandle");
        callFooUsingMethodHandle(new Derived(), 5.0, Double.TYPE);
        callFooUsingMethodHandle(new Derived(), 5, Integer.TYPE);
    }

    private static void callFooUsingMethodHandle(Base instance, Object data, Class<?> dataType) throws Throwable {
        MethodHandles.Lookup lookup = MethodHandles.lookup();

        lookup.findVirtual(instance.getClass(), "foo", MethodType.methodType(void.class, dataType)).bindTo(instance).invoke(data);
    }

    public static void callFooOn(Base instance) {
        instance.foo(5.0);
        instance.foo(5);
    }
}

