package sample;

import java.lang.invoke.*;

public class Sample {
    public double doubleIt(int value) {
        System.out.println("doubleIt called with " + value);
        return value * 2;
    }

    public static void main(String[] args) throws Throwable {
        CallSite callSite = createHandle();
        MethodHandle methodHandle = callSite.dynamicInvoker(); 
	//The Java source code equivalent of invokedynamic

        methodHandle.invoke(1);
        methodHandle.invoke(2);
        methodHandle.invoke(3);
    }

    private static CallSite createHandle() throws NoSuchMethodException, IllegalAccessException {
        MethodHandles.Lookup lookup = MethodHandles.lookup();
        MethodHandle handle = lookup.findVirtual(Sample.class, "doubleIt", MethodType.methodType(Double.TYPE, Integer.TYPE));
        MethodHandle handleOnInstance = handle.bindTo(new Sample());
        return new ConstantCallSite(handleOnInstance);
    }
}
